#include  "mk7a11p.inc"   ;ĵ"mk7a11p.inc"ļ
;------------------------------------------------------------------------
;оƬͺţmk7a11p 
;------------------------------------------------------------------------ 
;üĴ˵CONFIG 
;1-----------FOSC=NS     ;LS,NS,HS,RC    
;2-----------INRC=OFF     ;ON,OFF 
;3-----------CPT=OFF     ;ON,OFF    
;4-----------WDTE=Disable    ;Enable,Disable 
;5-----------LV=Low Vol Reset ON   ;Low Vol Reset ON,Low Vol Reset OFF 
;6-----------RESET=...reset...    ;...input...,...reset... 
;------------------------------------------------------------------------ 
rxbuf   	equ   		0x20  		;ջĴ 
txbuf   	equ   		0x21  		;ͻĴ 
count          	equ          	0x22     	;ֽڼĴ 
dat_r          	equ           	0x23   		;ݻ 
dis_r          	equ           	0x24      	; 
;------------------------------------------------------------------------ 
data1   	equ   		0x31 
data2   	equ   		0x32 
data3     	equ   		0x33 
data4     	equ   		0x34 
data5     	equ   		0x35 
data6     	equ   		0x36 
data7     	equ   		0x37 
;------------------------------------------------------------------------ 
#define		scl           	7           	;ʱ 
#define         sda         	6             	; 
;------------------------------------------------------------------------ 
                org		0x3ff   	;mk7a11pĸλַ 
                lgoto		main   		;ת  
;------------------------------------------------------------------------ 
     		org		0x100		;ڵַ     
main                                                                                         
                ;PortA˿ڷ״̬趨     
                movla           b'11110000' 
                iodir		porta 
                clr    		porta 
                clr		pa_pdm 
                ;--------------------------------------------------------
                ;PortB˿ڷ״̬趨  
                movla		b'00000000' 
                iodir		portb 
                movam   	pb_pup 
                clr    		portb 
                clr           	pb_pod 
                clr           	pb_pdm 
                clr    		wake_up 
                ;--------------------------------------------------------
                ;жϽֹ 
                clr		irqm 
                clr             irqf 
                ;-------------------------------------------------------- 
                ;TMR0,ԤƵΪ1:8 
                ;TMR0ʼֵΪ250 
                ;movla          b'11000010' 
                ;select 
                ;movla   	.250 
                ;movam   	tmr0 
                ;--------------------------------------------------------
                ;0x31-0x37RAM              
                movla   	0x71 
                movam   	data1 
                movla   	0x62 
                movam   	data2 
                movla   	0x53 
                movam   	data3 
                movla   	0x44 
                movam   	data4 
                movla   	0x35 
                movam   	data5 
                movla   	0x26 
                movam   	data6 
                movla   	0x17 
                movam   	data7 
                ;--------------------------------------------------------- 
                clr		0x38 
                clr		0x39 
                clr		0x3a 
                clr		0x3b 
                clr		0x3c 
                clr		0x3d 
                clr		0x3e 
                ;---------------------------------------------------------
                btss             status,pd   
                lgoto            read_data 
;-------------------------------------------------------------------------
write_data 
     		;0x31-0x37RAMݶֱ 
     		;д24C32A0011h-0017hַ 
     		;--------------------------------------------------------------------
     		lcall   	condstart  	;ʼ 
     		;--------------------------------------------------------------------
                movla   	0xa0 
         	movam   	txbuf 
                lcall   	tx8bit  	;д 
         	;----------------------------------------------------------------
         	movla   	0x00 
         	movam   	txbuf 
         	lcall   	tx8bit  	;дַ1 
      		;-------------------------------------------------------------------
      		movla  		0x10 
      		movam  		txbuf 
      		lcall   	tx8bit   	;дַ2 
      		;------------------------------------------------------------------- 
      		movla  		0x31 
      		movam  		fsr    		;fsrָ0x31 
write_loop 
  		mov   		indf,a 
  		movam  		txbuf 
  		lcall  	 	tx8bit   	; 
  		;-----------------------------------------------------------------------
  		inc   		fsr,m    	;fsrָһĴ 
  		;-----------------------------------------------------------------------
  		mov   		fsr,a 
  		andla   	b'00111111' 
  		xorla   	0x38 
  		btss   		status,z 
  		lgoto   	write_loop   	;7δ 
  		;----------------------------------------------------------------------- 
  		lcall   	condstop   	; 
  		lgoto          	into_sleep 
;------------------------------------------------------------------------- 
read_data 
  		;ֱ24C32A0011h-0017hַ 
  		;-----------------------------------------------------------------------
  		lcall   	condstart   	;ʼ 
  		;-----------------------------------------------------------------------
         	movla  		0xa0 
      		movam  		txbuf 
          	lcall   	tx8bit   	;д 
      		;-------------------------------------------------------------------
      		movla  		0x00 
      		movam  		txbuf 
      		lcall   	tx8bit   	;дַ1 
      		;-------------------------------------------------------------------
      		movla  		0x10 
      		movam  		txbuf 
      		lcall   	tx8bit   	;дַ2 
      		;-------------------------------------------------------------------
      		;------------------------------------------------------------------- 
  		lcall   	condstart   	;ʼ 
  		;-----------------------------------------------------------------------
      		movla  		0xa1 
      		movam  		txbuf 
      		lcall   	tx8bit   	;Ͷ 
  		;-----------------------------------------------------------------------
  		movla  		0x38 
  		movam  		fsr 
read_loop 
  		lcall   	rx8bit   	; 
  		;----------------------------------------------------------------------- 
  		mov   		rxbuf,a 
  		movam  		indf    	;ݱ 
                                          	;fsrǰָļĴ 
  		;-----------------------------------------------------------------------
  		inc   		fsr,m    	;fsrָһĴ 
  		;----------------------------------------------------------------------- 
  		mov   		fsr,a 
  		andla   	b'00111111' 
  		xorla   	0x3f 
  		btsc   		status,z 
  		lgoto   	read_end   	;һݲӦ 
  		;-----------------------------------------------------------------------
rxack 
  		bc   		portb,sda   	; 
  		nop 
  		nop 
  		nop 
  		nop 
  		nop 
  		bs   		portb,scl   	;Ӧź 
  		nop 
  		nop 
  		nop 
  		nop 
  		bc   		portb,scl   	;Ӧźŷɽʱ 
  		lgoto   	read_loop 
  		;----------------------------------------------------------------------
read_end 
  		movla  		b'00000000' 
  		iodir   	portb    	;sclsdaΪ 
  		nop 
  		bs   		portb,sda 
  		bc   		portb,scl 
  		nop 
  		nop 
  		nop 
  		nop 
  		nop 
  		nop 
  		nop 
  		bs   		portb,scl 
  		lcall   	condstop 
  		;----------------------------------------------------------------------
  		movla  		0x38 
  		movam  		fsr             ;ݺfsrָ0x38 
;------------------------------------------------------------------------
display 
      		mov          	dis_r,a 
         	add         	fsr,m		;fsrָָļĴ 
         	mov           	indf,a 
         	movam        	dat_r		;ָĴ 
                                         	;͸Ĵ 
        	;----------------------------------------------------------------
          	movla         	b'00001111' 
         	and          	dat_r,a 
        	movam        	porta		;Ĵĵ4bit 
                                        	;͸PortAʾ 
          	;--------------------------------------------------------------
       		rr             	dat_r,m 
         	rr             	dat_r,m 
         	rr            	dat_r,m 
       	 	rr           	dat_r,m 
         	movla        	b'00000111' 
        	and          	dat_r,a 
          	movam        	portb		;Ĵĸ3bit 
                                          	;͸PortBʾ 
       		;-----------------------------------------------------------------
         	inc           	dis_r,m 
      		movla         	.7 
         	sub         	dis_r,a 
         	btsc          	status,c 
         	clr          	dis_r 
;------------------------------------------------------------------------
into_sleep 
         	nop 
  		nop 
  		nop 
       		sleep 
  		nop 
  		nop 
  		nop 
;======================================================================== 
;ӳ 
condstart        ;I2Cӿź 
  		movla  		b'00000000' 
  		iodir   	portb    	;sclsdaΪ 
  		nop 
  		bs   		portb,sda 
  		nop 
  		bs   		portb,scl 
  		nop 
  		nop 
  		nop 
  		nop 
  		bc   		portb,sda 
  		nop 
  		nop 
  		nop 
  		nop 
  		bc   		portb,scl 
  		ret 
;------------------------------------------------------------------------ 
condstop 
         	movla  		b'00000000' 
  		iodir   	portb    	;sclsdaΪ 
  		nop 
  		bs   		portb,scl 
  		nop 
  		bc   		portb,sda 
  		nop 
  		nop 
  		nop 
  		bs   		portb,sda 
  		nop 
  		nop 
  		nop 
  		ret 
;------------------------------------------------------------------------ 
rx8bit 
  		movla  		b'01000000' 
  		iodir   	portb    	;sclΪ,sdaΪ 
  		clr   		rxbuf 
  		movla  		.8 
  		movam  		count 
rxlp 
  		bc   		portb,scl 
  		nop 
  		nop 
  		nop 
  		bs   		portb,scl 
  		nop 
  		nop 
  		nop 
  		bc   		status,c 
  		btsc   		portb,sda 
  		bs   		status,c 
  		rl   		rxbuf,m 
  		decsz   	count,m 
  		lgoto   	rxlp 
  		bc   		portb,scl   	;ʱ 
  		movla  		b'00000000' 
  		iodir   	portb    	;sclsdaΪ 
  		ret 
;----------------------------------------------------------------------- 
tx8bit              
         	movla  		b'00000000' 
  		iodir   	portb    	;sclsdaΪ 
         	movla  		.8 
  		movam  		count 
txlp 
        	rl   		txbuf,m 
  		btsc   		status,c 
  		bs   		portb,sda   	;趨1ʱΪʱ趨ݣ 
         	btss   		status,c 
  		bc   		portb,sda   	;趨0ʱΪʱ趨ݣ 
  		nop 
  		nop 
  		nop 
  		bs   		portb,scl   	;һλݣЧ 
  		nop 
  		nop 
  		nop 
  		bc   		portb,scl   	;ʱ 
  		decsz   	count,m 
  		lgoto   	txlp 
  		;----------------------------------------------------------------------
  		movla  		b'01000000' 
  		iodir   	portb    	;sclΪ,sdaΪ 
  		nop 
txack 
          	bc   		portb,scl   	;ʱ 
  		nop 
  		nop 
  		nop 
  		bs   		portb,scl   	;һ 
  		nop 
  		nop 
  		nop 
  		btsc   		portb,sda 
  		lgoto   	txack    	;δյźţ 
  		bc   		portb,scl   	;յӦźźʱ 
  		ret  
		;----------------------------------------------------------------------- 
       		end 